module Proxtopus
  class Resource
    
    attr_reader :url, :params, :format, :elements 
    
    def initialize(request, response)
      raise ArgumentError, "Resource.new() expects request as a hash of config values!" if !request.is_a?(Hash)
      raise ArgumentError, "Resource.new() expects response as a hash of config values!" if !response.is_a?(Hash)

      #@request = resource[:request]               || raise(ArgumentError, "Resource must have a specified request hash!")
      #@response = resource[:response]             || raise(ArgumentError, "Resource must have a specified resource hash!")
      @url = request[:url]                        || raise(ArgumentError, "Resource must have a specified request url!")
      @params = request[:params]                  || nil
      @format = response[:format]                 || raise(ArgumentError, "Resource must have a specified resource format!")
      @elements = response[:elements]             || raise(ArgumentError, "Resource must have a specified resource set of elemenra!")

      #if resource.is_a?(Proxtopus::Resource)
      #  @request = resource.request
      #  @response = resource.response
      #  @url = resource.url
      #  @params = resource.params
      #  @format = resource.format
      #  @elements = resource.elements
      #elsif resource.is_a?(Hash)
      #  @request = resource[:request]               || raise(ArgumentError, "Resource must have a specified request hash!")
      #  @response = resource[:response]             || raise(ArgumentError, "Resource must have a specified resource hash!")
      #  @url = resource[:request][:url]             || raise(ArgumentError, "Resource must have a specified request url!")
      #  @params = resource[:request][:params]       || raise(ArgumentError, "Resource must have a specified request param!")
      #  @format = resource[:response][:format]      || raise(ArgumentError, "Resource must have a specified resource format!")
      #  @elements = resource[:response][:elements]  || raise(ArgumentError, "Resource must have a specified resource set of elemenra!")
      #else
      #  raise ArgumentError, "Resource.new() expects resource as a Proxtopus::Resource or Hash!"
      #end
    end
    
    def collect
      #request = Request.new(self)
      #results = Request.new(self).response.parsed
      #puts "[RESULTS]"
      #puts results.inspect
      #puts
      #puts
      #results
    end
    
    def uri
      uri = URI(@url.to_s)
      uri.query = URI.encode_www_form(@params)
      uri
    end
    
    def ==(other)
      if other.is_a?(Proxtopus::Resource)
        if @url == other.url && @params == other.params
          true
        else
          false
        end
      else
        false
      end
    end
    
  end
end