module Proxtopus
  
  class Client
    attr_accessor :resources, :proxies
  
    # called by Proxtopus.configure, returns self
    #def initialize(&block)
    #  @agent = Mechanize.new
    #  @proxies = ProxySet.new
    #  instance_eval(&block) if block_given?
    #  self
    #end
    def initialize(resources)
      #@api_url = api_url
      #@api_options = api_options
      @resources = ResourceSet.new(resources)
      @proxies = ProxySet.new
      self
    #rescue => e
    #  puts "Proxtopus::Client -- #{e.inspect}"
    end
    
    # p.collect({:cs => ['US'], etc...})
    # if no options are supplied, api_options will be used
    def collect(opts=nil)
      #use_opts = (opts.nil?)? api_options : opts
      #get(use_opts)
      @resources.each do |resource|
        response = Request.get(resource)
        #puts response.proxies.inspect
        #gets
        @proxies.push(response.proxies)
      end
      #puts "[@proxies in Client]"
      #puts @proxies.inspect
      #puts
      #puts
      #gets
      @proxies
    #rescue => e
    #  puts "Proxtopus::Client -- #{e.inspect}"
    end
    
    def random_proxy
      @proxies[rand(0..(@proxies.count-1))]
    #rescue => e
    #  puts "Proxtopus::Client -- #{e.inspect}"
    end
    
    def delete_proxy(proxy)
      @proxies.delete(proxy)
    #rescue => e
    #  puts "Proxtopus::Client -- #{e.inspect}"
    end
    
  private
  
=begin
    def get(opts)
      begin
        json = @agent.get(Request.build(api_url, opts)).body
        JSON.parse(json)["data"].each do |p|
          @proxies.push(p)
        end
      rescue => e
        puts "[FAIL] Unexpected exception when trying to get proxy: #{e.inspect}"
        puts
        exit
      end
    end
=end
  end
  
end