module Proxtopus
  class ResourceSet < Array
    
    def initialize(resources=nil)
      if resources.is_a?(Array)
        resources.each { |r| push(r) }
      end
    end
    
    def push(resource)
      if !resource.is_a?(Proxtopus::Resource) && !resource.is_a?(Hash)
        raise ArgumentError, "A ResourceSet may only contain Resource or Hash objects!"
      end
      
      if resource.is_a?(Hash)
        resource = Resource.new(resource[:request], resource[:response])
      end
      
      super(resource) if !include?(resource)
      self
    end

=begin    
    def shift(resource)
      if !resource.is_a?(Proxtopus::Resource) && !resource.is_a?(Hash)
        raise ArgumentError, "A ResourceSet may only contain Resource or Hash objects!"
      end
      
      if resource.is_a?(Hash)
        resource = Resource.new(resource['host'], resource['port'], resource['protocol'], resource['country'], resource['anonymity'])
      end
      
      super(resource) if !include?(resource)
      self
    end
=end
    
    def include?(resource)
      if resource.is_a?(Proxtopus::Resource)
        each do |p|
          return true if resource == p
        end
        false
      else
        false
      end
    end
    
  end
end